Codeforces Round #525 (Div. 2)

Codeforces Round #525 (Div. 2)

glhf

T1:

题意:求两个数\(a,b\)使\(1<=a,b<=n\),\(a\)%\(b==0\),\(a/b<n\),\(a*b>n\)

\(n<=100\)

当时直接打了暴力

#include<map>
#include<queue>
#include<cmath>
#include<bitset>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
typedef long long ll;
int n;
int main(){
    scanf("%d",&n);
    for(int i=1;i<=n;i++)
        for(int j=1;j<=i;j++){
            if(i%j==0&&i*j>n&&i/j<n){
                printf("%d %d\n",i,j);
                return 0;
            }
        }
    printf("-1\n");
    return 0;
}

后来hack人的时候发现还可以这么写(我是sb

#include<map>
#include<queue>
#include<cmath>
#include<bitset>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
typedef long long ll;
int n;
int main(){
    scanf("%d",&n);
    if(n>1) printf("%d %d\n",n,n);
    else printf("-1\n");
    return 0;
}

T2:

直接sort去重,从大到小减,记着减了多少

#include<map>
#include<queue>
#include<cmath>
#include<bitset>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
typedef long long ll;
const int maxn=1e5+100;
int n,k,a[maxn],b[maxn],num,cnt;
int main(){
    //freopen(".out","w",stdout);
    scanf("%d%d",&n,&k);
    for(int i=1;i<=n;i++)
        scanf("%d",&a[i]);
    sort(a+1,a+n+1);
    a[0]=-1;
    for(int i=1;i<=n;i++)
        if(a[i]!=a[i-1])
            b[++num]=a[i];
    for(int i=1;i<=num;i++){
        int x=b[i]-cnt;
        if(x>0){
            printf("%d\n",x);
            cnt+=x;
            k--;
            if(k==0) return 0;
        }
    }
    for(int i=1;i<=k;i++) printf("0\n");
    return 0;
}

T3:

模拟...?!

题目给了\(n+1\)次机会,我们先用前\(n\)次机会做加法,把\(a\)数组的值变为膜n意义下为\(0,1,2,3...n-1\)(因为是膜意义下,你从后往前考虑每个元素,一直加就是了)

最后所有元素对\(n\)取膜,\(a\)数组就真的变成了\(0,1,2,3...n-1\)

#include<map>
#include<queue>
#include<cmath>
#include<bitset>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
typedef long long ll;
const int maxn=1e4+100;
int n,a[maxn],y;
int main(){
    freopen("1.in","r",stdin);
    //freopen(".out","w",stdout);
    scanf("%d",&n);
    printf("%d\n",n+1);
    for(int i=1;i<=n;i++) scanf("%d",&a[i]);
    for(int i=n;i>=1;i--){
        int x=0;
        y%=n;
        while(1){
            if((y+a[i])%n==n-(n-i+1)) break;
            x++;
            y++;
        }
        printf("1 %d %d\n",i,x);
    }
    printf("2 %d %d",n,n);
    return 0;
}

T4:

交互题啊。。。mmp

根本不知道怎么测试对错,硬着头皮提交,竟然1A??!

思路是从高位向低位去试探,一开始先问\(0,0\),得到大小关系

第一次用二进制的100000 (29个0)去亦或两个数,读取结果

如果两个数大小关系变了,说明两个数的这一位不一样,讨论一下,得到哪个是1哪个是0,同时记\(ny,my\)加上1或0,这个\(ny,my\)就是前面位已经确定的

如果大小关系没变,用100000(29个0)去亦或第一个数,0去亦或第二个数,如果第一个数小,说明两个数的这一位都是1,要不就都是0。

第二次用二进制的100000(28个0)+ny,100000(28个0)+my,去亦或两个数...和上面一样...

最后得到了结果...其实就是\(ny,my\),请无视\(n,m\)

#include<map>
#include<queue>
#include<cmath>
#include<bitset>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
typedef long long ll;
int n,m,an,ny,my,bn;
int main(){
    freopen("1.in","r",stdin);
    //freopen(".out","w",stdout);
    printf("? 0 0\n");
    fflush(stdout);
    scanf("%d",&an);
    for(int i=29;i>=0;i--){
        int x=1<<i;
        ny+=x,my+=x;
        printf("? %d %d\n",ny,my);
        fflush(stdout);
        ny-=x,my-=x;
        scanf("%d",&bn);
        if(an*bn<0){
            if(an==1) n+=x,ny+=x;
            else m+=x,my+=x;
            printf("? %d %d\n",ny,my);
            fflush(stdout);
            scanf("%d",&an);
        }
        else{
            ny+=x;
            printf("? %d %d\n",ny,my);
            fflush(stdout);
            ny-=x;
            scanf("%d",&bn);
            if(bn==-1){
                ny+=x,my+=x;
                n+=x,m+=x;
            }
        }
    }
    printf("! %d %d\n",n,m);
    fflush(stdout);
    return 0;
}

T5:

应该是一道01分数规划题,感觉像是最大密度子图??

然而我并不会打

GG

原文地址:https://www.cnblogs.com/nianheng/p/10068556.html

时间: 2024-08-30 18:22:20

Codeforces Round #525 (Div. 2)的相关文章

Codeforces Round #525 (Div. 2)A. Ehab and another construction problem

A. Ehab and another construction problem 题目链接:https://codeforc.es/contest/1088/problem/A 题意: 给出一个x,找出这样的a,b满足:1<=a,b<=x,并且a%b=0,a/b<x,a*b>x. 题解: 赛后发现,除开x=1的情况,其它情况a=b=x就可以满足条件了... 但还是附上比赛时候的代码吧... #include <bits/stdc++.h> using namespace

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #424 (Div. 2) D. Office Keys(dp)

题目链接:Codeforces Round #424 (Div. 2) D. Office Keys 题意: 在一条轴上有n个人,和m个钥匙,门在s位置. 现在每个人走单位距离需要单位时间. 每个钥匙只能被一个人拿. 求全部的人拿到钥匙并且走到门的最短时间. 题解: 显然没有交叉的情况,因为如果交叉的话可能不是最优解. 然后考虑dp[i][j]表示第i个人拿了第j把钥匙,然后 dp[i][j]=max(val(i,j),min(dp[i-1][i-1~j]))   val(i,j)表示第i个人拿

Codeforces Round #424 (Div. 2) C. Jury Marks(乱搞)

题目链接:Codeforces Round #424 (Div. 2) C. Jury Marks 题意: 给你一个有n个数序列,现在让你确定一个x,使得x通过挨着加这个序列的每一个数能出现所有给出的k个数. 问合法的x有多少个.题目保证这k个数完全不同. 题解: 显然,要将这n个数求一下前缀和,并且排一下序,这样,能出现的数就可以表示为x+a,x+b,x+c了. 这里 x+a,x+b,x+c是递增的.这里我把这个序列叫做A序列 然后对于给出的k个数,我们也排一下序,这里我把它叫做B序列,如果我

[Codeforces] Round #352 (Div. 2)

人生不止眼前的狗血,还有远方的狗带 A题B题一如既往的丝帛题 A题题意:询问按照12345678910111213...的顺序排列下去第n(n<=10^3)个数是多少 题解:打表,输出 1 #include<bits/stdc++.h> 2 using namespace std; 3 int dig[10],A[1005]; 4 int main(){ 5 int aa=0; 6 for(int i=1;;i++){ 7 int x=i,dd=0; 8 while(x)dig[++dd

Codeforces Round #273 (Div. 2)

Codeforces Round #273 (Div. 2) 题目链接 A:签到,仅仅要推断总和是不是5的倍数就可以,注意推断0的情况 B:最大值的情况是每一个集合先放1个,剩下都丢到一个集合去,最小值是尽量平均去分 C:假如3种球从小到大是a, b, c,那么假设(a + b) 2 <= c这个比較明显答案就是a + b了.由于c肯定要剩余了,假设(a + b)2 > c的话,就肯定能构造出最优的(a + b + c) / 3,由于肯定能够先拿a和b去消除c,而且控制a和b成2倍关系或者消除

Codeforces Round #339 (Div. 2) B. Gena&#39;s Code

B. Gena's Code It's the year 4527 and the tanks game that we all know and love still exists. There also exists Great Gena's code, written in 2016. The problem this code solves is: given the number of tanks that go into the battle from each country, f

Codeforces Round #315 (Div. 1)

A. Primes or Palindromes? time limit per test 3 seconds memory limit per test 256 megabytes input standard input output standard output Rikhail Mubinchik believes that the current definition of prime numbers is obsolete as they are too complex and un

DP Codeforces Round #303 (Div. 2) C. Woodcutters

题目传送门 1 /* 2 题意:每棵树给出坐标和高度,可以往左右倒,也可以不倒 3 问最多能砍到多少棵树 4 DP:dp[i][0/1/2] 表示到了第i棵树时,它倒左或右或不动能倒多少棵树 5 分情况讨论,若符合就取最大值更新,线性dp,自己做出来了:) 6 */ 7 #include <cstdio> 8 #include <algorithm> 9 #include <cstring> 10 #include <cmath> 11 #include &